// Esempio di Davide Achilli IZ2UUF - 18/02/2014
#include <LiquidCrystal.h>

// Questo è un commento

// initialize the library with the numbers of the interface pins
LiquidCrystal lcd(7, 6, 5, 4, 3, 2);

void setup ()
{
  lcd.begin (16, 2);

  pinMode (13, OUTPUT);
  pinMode (12, OUTPUT);
  pinMode (11, INPUT);
  pinMode (8, INPUT);
  pinMode (9, INPUT);
  
  lcd.setCursor (0, 0);
}

/*================================================================
  ENCODER
===============================================================*/
#define ASPETTO_11         1
#define ASPETTO_10_o_01    2
#define ASPETTO_00         3
int StatoEncoder = ASPETTO_11;
// Se -1 ruotato a sinistra
// Se +1 ruotato a destra
int EventoEncoder = 0;

void Encoder ()
{
  int Pin1 = digitalRead (8);
  int Pin2 = digitalRead (9);
  
  switch (StatoEncoder) {
    case ASPETTO_11: {
      if (Pin1 && Pin2) StatoEncoder = ASPETTO_10_o_01;
      break;
    }
  
    case ASPETTO_10_o_01: {
      if (Pin1 && !Pin2) {
        EventoEncoder = -1;
        StatoEncoder = ASPETTO_00;
      }
      if (!Pin1 && Pin2) {
        EventoEncoder = 1;
        StatoEncoder = ASPETTO_00;
      }
      break;
    }
    
    case ASPETTO_00: {
      if (!Pin1 && !Pin2) StatoEncoder = ASPETTO_11;
      break;
    }
  }
}

/*================================================================
  PULSANTE 1
===============================================================*/
int UltimoStatoPulsante1 = 0;
int Pulsante1Premuto = 0;
int Pulsante1PremutoLungo = 0;
unsigned long TempoPressionePulsante1Ms = 0;
void Pulsante1 ()
{
  if (digitalRead (11)) {
    if (UltimoStatoPulsante1 == 0) {
      TempoPressionePulsante1Ms = millis ();
    }
    UltimoStatoPulsante1 = 1;
  }
  else {
    // Se è premuto
    if (UltimoStatoPulsante1 == 1) {
      if (millis () - TempoPressionePulsante1Ms > 2000) {
        // Qui attiviamo l'evento
        Pulsante1PremutoLungo = 1;
      }
      else {
        // Qui attiviamo l'evento
        Pulsante1Premuto = 1;
      }
    }
    // Se non è premuto
    UltimoStatoPulsante1 = 0;
  }
}

/*================================================================
  LED GIALLO
================================================================*/
unsigned long ProssimaTransizioneLedGialloInMs = 0;
int LedGialloAcceso = 0;
int LedGialloAttivo = 1;
int PeriodoLedGialloInMs = 400;
void LedGiallo ()
{
  if (Pulsante1Premuto) {
    Pulsante1Premuto = 0;
    LedGialloAttivo = !LedGialloAttivo;
    if (!LedGialloAttivo) {
      digitalWrite (13, LOW);
      PeriodoLedGialloInMs = 400;
    }
  }
  
  if (Pulsante1PremutoLungo) {
    if (PeriodoLedGialloInMs > 100) {
      PeriodoLedGialloInMs = 50;
    }
    Pulsante1PremutoLungo = 0;
  }
  if (LedGialloAttivo) {
    if (millis () >= ProssimaTransizioneLedGialloInMs) {
      if (LedGialloAcceso) {
        digitalWrite (13, LOW);
        ProssimaTransizioneLedGialloInMs = millis () + PeriodoLedGialloInMs;
        LedGialloAcceso = 0;
      }  
      else {
        digitalWrite (13, HIGH);
        ProssimaTransizioneLedGialloInMs = millis () + PeriodoLedGialloInMs;
        LedGialloAcceso = 1;
      }
    }
  }
}

/*================================================================
  LED VERDE
================================================================*/
unsigned long ProssimaTransizioneLedVerdeInMs = 0;
int LedVerdeAcceso = 0;
int NoLampeggiVerdi = 0;
int PeriodoLedVerde = 1000;
void LedVerde ()
{
  switch (EventoEncoder) {
    case -1: if (PeriodoLedVerde > 100) PeriodoLedVerde-= 100; EventoEncoder=0; break;
    case 1: if (PeriodoLedVerde < 2000) PeriodoLedVerde+= 100; EventoEncoder=0; break;
  }
  
  if (millis () >= ProssimaTransizioneLedVerdeInMs) {
    if (LedVerdeAcceso) {
      digitalWrite (12, LOW);
      ProssimaTransizioneLedVerdeInMs = millis () + PeriodoLedVerde;
      LedVerdeAcceso = 0;
    }
    else {
      digitalWrite (12, HIGH);
      ProssimaTransizioneLedVerdeInMs = millis () + PeriodoLedVerde;
      LedVerdeAcceso = 1;
    }
  }
}

/*================================================================
  DISPLAY
================================================================*/
unsigned long ProssimoUpdateDisplayMs = 0;
void Display ()
{
  if (millis () >= ProssimoUpdateDisplayMs) {
    ProssimoUpdateDisplayMs = millis ()+100;
    lcd.setCursor (0, 0);
    lcd.print ("P=");
    lcd.print (PeriodoLedVerde);
    lcd.print ("   ");
    lcd.setCursor (0, 1);
    lcd.print ("T=");
    lcd.print (analogRead (0));
  }
}

void loop ()
{
  LedGiallo ();
  LedVerde ();
  Pulsante1 ();
  Encoder ();
  Display ();
}
